<template>
	<div class="tile-container">
		<Tile
			v-for="(book, index) in unpickedBooks"
			:key="index"
			:book="book"
			@clickedTile="clickedTile"
		/>
	</div>
	<br />
	<p>Picked</p>
	<div class="tile-container">
		<Tile
			v-for="(book, index) in pickedBooks"
			:key="index"
			:book="book"
			@clickedTile="clickedTile"
		/>
		<i v-show="pickedBooks.length === 0">None</i>
	</div>
	<button v-show="showResetButton" @click="reset">Reset</button>
	<div v-if="showModal">
		<Modal @close="closeModal">
			<template v-slot:header>
				<h3>Congrats</h3>
			</template>
			<template v-slot:body>
				<p>All of books are already picked!</p>
				<p>Your time: {{ timeInSeconds }} seconds</p>
			</template>
			<template v-slot:buttons>
				<button @click="closeModal">Close</button>
			</template>
		</Modal>
	</div>
</template>

<script>
import Tile from "./Tile.vue";
import Modal from "../Modal/Modal.vue";

let firstClickedData = null;

export default {
	name: "PickOneTrue",
	components: {
		Tile,
		Modal,
	},
	data() {
		return {
			books: [
				{
					id: "asis",
					title: "A Study in Scarlet",
					author: "Sir A. C. Doyle",
					url: "https://en.wikipedia.org/wiki/A_Study_in_Scarlet",
					imageUrl:
						"https://upload.wikimedia.org/wikipedia/commons/archive/2/2c/20081206002312%21ArthurConanDoyle_AStudyInScarlet_annual.jpg",
					isSold: false,
					picked: false,
					selected: false,
				},
				{
					id: "asof",
					title: "The Sign of the Four",
					author: "Sir A. C. Doyle",
					url: "https://en.wikipedia.org/wiki/The_Sign_of_the_Four",
					imageUrl:
						'https://upload.wikimedia.org/wikipedia/commons/thumb/a/af/"The_Sign_of_the_Four"_in_Lippincott’s_Monthly_Magazine_%281890%29.jpg/159px-"The_Sign_of_the_Four"_in_Lippincott’s_Monthly_Magazine_%281890%29.jpg',
					isSold: true,
					picked: false,
					selected: false,
				},
				{
					id: "hfb",
					title: "His Last Bow",
					author: "Sir A. C. Doyle",
					url: "https://en.wikipedia.org/wiki/His_Last_Bow",
					imageUrl:
						"https://upload.wikimedia.org/wikipedia/commons/3/3c/His_Last_Bow_1917_cover.jpg",
					isSold: false,
					picked: false,
					selected: false,
				},
				{
					id: "asis",
					title: "A Study in Scarlet",
					author: "Sir A. C. Doyle",
					url: "https://en.wikipedia.org/wiki/A_Study_in_Scarlet",
					imageUrl:
						"https://upload.wikimedia.org/wikipedia/commons/archive/2/2c/20081206002312%21ArthurConanDoyle_AStudyInScarlet_annual.jpg",
					isSold: false,
					picked: false,
					selected: false,
				},
				{
					id: "asof",
					title: "The Sign of the Four",
					author: "Sir A. C. Doyle",
					url: "https://en.wikipedia.org/wiki/The_Sign_of_the_Four",
					imageUrl:
						'https://upload.wikimedia.org/wikipedia/commons/thumb/a/af/"The_Sign_of_the_Four"_in_Lippincott’s_Monthly_Magazine_%281890%29.jpg/159px-"The_Sign_of_the_Four"_in_Lippincott’s_Monthly_Magazine_%281890%29.jpg',
					isSold: true,
					picked: false,
					selected: false,
				},
				{
					id: "hfb",
					title: "His Last Bow",
					author: "Sir A. C. Doyle",
					url: "https://en.wikipedia.org/wiki/His_Last_Bow",
					imageUrl:
						"https://upload.wikimedia.org/wikipedia/commons/3/3c/His_Last_Bow_1917_cover.jpg",
					isSold: false,
					picked: false,
					selected: false,
				},
			],
			pickedBooks: [],
			showModal: false,
			showResetButton: false,
			timer: null,
			time: 0,
		};
	},
	methods: {
		closeModal() {
			this.showModal = !this.showModal;
		},
		clickedTile(book) {
			if (!book.picked) {
				book.selected = true;
				if (firstClickedData) {
					if (book.id === firstClickedData.id) {
						console.log("books are same");

						setTimeout(() => {
							book.selected = false;
							firstClickedData.selected = false;

							book.picked = true;
							firstClickedData.picked = true;

							this.pickedBooks = [
								...this.pickedBooks,
								book,
								firstClickedData,
							];
							firstClickedData = null;
						}, 300);
					} else {
						console.log("books are not same");

						setTimeout(() => {
							book.selected = false;
							firstClickedData.selected = false;

							firstClickedData = null;
						}, 300);
					}
				} else {
					book.selected = true;
					firstClickedData = book;
				}
			}
		},
		startTimer() {
			this.timer = setInterval(() => {
				this.time += 100;
			}, 100);
		},
		stopTimer() {
			clearInterval(this.timer);
			this.timer = null;
		},
		reset() {
			this.time = 0;
			this.showResetButton = false;
			for (let book of this.books) {
				book.picked = false;
			}
			this.pickedBooks = [];
			this.startTimer();
		},
	},
	computed: {
		unpickedBooks() {
			return this.books.filter((book) => !book.picked);
		},
		timeInSeconds() {
			return this.time / 1000;
		},
	},
	mounted() {
		this.startTimer();
	},
	watch: {
		pickedBooks: function(value) {
			if (value.length === this.books.length) {
				this.stopTimer();
				this.showModal = true;
				this.showResetButton = true;
			}
		},
	},
};
</script>

<style scope>
.tile-container {
	display: flex;
	flex-wrap: wrap;
}
</style>
